import {actionPromise} from "../reducers";
import {backURL} from "./gql-queries-backurl";
import {call, put, takeEvery} from "redux-saga/effects";
import {promiseWorker} from "../reducers/promiseReducer";
import {actionAboutMe} from "./about-me-actions";
import {actionFindMyTracks} from "./find-actions";

export const actionUploadTrack = (array) => {
    let fd = new FormData();
    fd.append("track", array)
    return actionPromise(
        "uploadFile",
        fetch(backURL+'/track', {
            method: "POST",
            headers: localStorage.authToken
                ? { Authorization: "Bearer " + localStorage.authToken }
                : {},
            body: fd,
        }).then((res) => res.json())
    );
};

export const actionFullUploadTrack = (array=[]) =>
    ({type:'FULL_UPLOAD_TRACK', array})



export function* fullUploadTrackWorker (action) {
    const {array} = action
    // console.log(array,'privet')
    if (array) {
    for (let i = 0; i < array.length; i++) {
        yield call(promiseWorker,actionUploadTrack(array[i]));
        yield put(actionFindMyTracks())
    }
    }
    yield put(actionAboutMe())
}


export function* fullUploadTrackWatcher () {
    yield takeEvery ('FULL_UPLOAD_TRACK',fullUploadTrackWorker)
}


//
// export const actionSetTrackToPlaylist = (playlistId,trackId) =>
//     ({type:'SET_TRACK_TO_PLAYLIST', playlistId,trackId})
//
//
// export function* setTrackToPlaylistWorker (action) {
//     const {playlistId,trackId} = action
//     yield call(
//         promiseWorker,actionPromise('createPlaylist', gql(`mutation p($playlist:PlaylistInput) {
//          PlaylistUpsert(playlist:$playlist) {
//          _id
//          }
//       }`, {playlist: {_id: playlistId,tracks:{_id: trackId }}}))
//     );
//     yield put(actionAboutMe());
// };
//
//
// export function* setTrackToPlaylistWatcher() {
//     yield takeEvery ('SET_TRACK_TO_PLAYLIST', setTrackToPlaylistWorker)
// }

