import {Redirect, Switch} from 'react-router-dom';
import {NoPlaylistMytracks} from "./my-tracks";
import {UserTracks} from "./user-tracks";
import {CAllTracks} from "./user-tracks";
import {CAllUsers} from "./user-tracks";
import {CMyPlaylists} from "./my-tracks";
import {CProtectedRoute} from "../reducers";
import {CSearchResult} from "./tools/search";
import {MyPlaylistTracks} from "./my-tracks";

export const Aside = ({children}) =>
    <div className='Aside'>
        {children}
    </div>

export const Content = ({children}) =>
    <div className='Content'>
        {children}
    </div>

export const Main = () =>
    <main>
        <Aside>
            <Switch>
            <CProtectedRoute roles={["anon", "user"]} path="/music" component={CAllUsers}/>
            <CProtectedRoute roles={["anon", "user"]} path="/user/:_id" component={CAllUsers}/>
            <CProtectedRoute roles={["anon", "user"]} path="/mymusic" component={CMyPlaylists}/>
            <CProtectedRoute roles={["anon", "user"]} path="/myplaylist/:_id" component={CMyPlaylists}/>
            <CProtectedRoute roles={["anon", "user"]} path='/' component={CAllUsers} exact/>
            </Switch>
        </Aside>
        <Content>
            <Redirect from='/main' to='/'/>
            <Switch>
                <CProtectedRoute roles={["anon", "user"]} path="/search" component={CSearchResult}/>
                <CProtectedRoute roles={["anon", "user"]} path="/music" component={CAllTracks}/>
                <CProtectedRoute roles={["anon", "user"]} path='/' component={NoPlaylistMytracks} exact/>
                <CProtectedRoute roles={["anon", "user"]} path="/myPlaylist/:_id" component={MyPlaylistTracks}/>
                <CProtectedRoute roles={["anon", "user"]} path="/user/:_id" component={UserTracks}/>
                <CProtectedRoute roles={["anon", "user"]} path='/mymusic' component={NoPlaylistMytracks}/>
            </Switch>
        </Content>
   </main>

