import {store} from "./store";
import {actionPromise} from "./promiseReducer";
import {backURL, gql} from "../actions";

export const playerReducer = (
    state = {},
    {type,track,trackIndex,isPlaying=false,isPaused,duration,
        playlist,playlistIndex,currentTime=0,volume=1,}) => {

    if (type === "TRACK_PLAY") {
        return {
            ...state,
            isPlaying,
            isPaused: !isPlaying,
        };
    }

    if (type === "TRACK_STOP") {
        return {
            ...state,
            isPaused,
            isPlaying: !isPaused,
        };
    }

    if (type === "TRACK_VOLUME") {
        return {
            ...state,
            volume,
        };
    }

    if (type === "TRACK_DURATION") {
        return {
            ...state,
            duration,
        };
    }

    if (type === "TRACK_CURRENT_TIME") {
        return {
            ...state,
            currentTime,
        };
    }

    if (type === "SET_PLAYLIST") {
        console.log(playlist,'lol')
        return {
            ...state,
            playlist,
        };
    }
    return state;
};



const audio = new Audio()



export const actionTrackPlay = (trackIndex) =>
    async (dispatch,getState) => {
        let {player:{playlistIndex,playlist}} = getState()

        if (playlistIndex !== trackIndex) {
            audio.src = backURL + '/'+ playlist.tracks[trackIndex].url
            await audio.load()
            audio.ondurationchange = function(){actionSetDuration()}
            audio.ontimeupdate = function(){actionTrackCurrentTime()}
        }
        await audio.play()
        await console.log(playlist,'uuuuu')
        await dispatch({type:"TRACK_PLAY",isPlaying:true,isPaused:false,trackIndex})
    }




// export const actionTrackPlay = (trackIndex) =>
//     async (dispatch, getState) => {
//          let {player} = getState ()
//         let url = player.playlist[trackIndex]?.url
//          let audioSrc = backURL + '/'+ url
//         audio.src = audioSrc
//         audio.load()
//         console.log(audioSrc,'uuuuu')
//         audio.ondurationchange = function(){actionSetDuration()}
//         audio.ontimeupdate = function(){actionTrackCurrentTime()}
//         audio.play()
//         await dispatch({type:"TRACK_PLAY",isPlaying:true,isPaused:false})
//     }



export const actionTrackStop = () => {
    audio.pause()
    store.dispatch({type:"TRACK_STOP",isPlaying:false,isPaused:true})
}


export const actionTrackVolume = (e) => {
    audio.volume = e
    store.dispatch({type:"TRACK_VOLUME", volume:e})
}


export const actionSetDuration = () => {
    let e = audio.duration
    store.dispatch({type:"TRACK_DURATION",duration:e})
}

export const actionTrackCurrentTime = () => {
    let e = audio.currentTime
    store.dispatch({type:"TRACK_CURRENT_TIME", currentTime:e})
}

export const actionSetPlaylist = (playlist,trackIndex) => {
        store.dispatch({type:"SET_PLAYLIST",playlist:playlist})
         actionTrackPlay(trackIndex)
    }


